#property copyright "Copyright  2008 IceXP"
#property link "icexp@narod.ru"
/**********************************
* Modified by Dimsh 2008-07-06    *
**********************************/

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

extern int bars=100,calculate=10000,future=10;
extern double width=1.2;

double out[];

datetime prev_time = 0;

int init()
{
   if(calculate > Bars - 1)
      calculate = Bars - 1;
   if(bars > Bars - 1)
      bars = Bars - 1;
      
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0, 159);
    SetIndexBuffer(0,out);
    SetIndexLabel(0,"Rbn++");
    Comment("\nCopyright  2008 IceXP");
    IndicatorShortName("Rbn++ ("+bars+", "+calculate+", "+future+", "+", "+DoubleToStr(width,2)+")");
    return(0);
}

int deinit()
{
    for (int i= ObjectsTotal(); i>=0; i--)
      if (StringSubstr(ObjectName(i), 0, StringLen("Rbn++_Index")) == "Rbn++_Index")
         ObjectDelete(ObjectName(i));
    Comment("");
    return(0);
}

int start()
{
   if (prev_time == Time[0])
      return(0);
   prev_time = Time[0];
   
    for(int i=bars;i>=0;i--) 
      out[i]=def(i);
    for(int y=-1;y>=-future;y--)
    {
        ObjectCreate("Rbn++_Index="+y,22,0,Time[0]-y*Period()*60,def(y));
        ObjectSet("Rbn++_Index="+y,OBJPROP_ARROWCODE,159);
        ObjectSet("Rbn++_Index="+y,OBJPROP_COLOR,Red); 
    }
    return(0);
}

// def for Bar x should give me the expected close price of that Bars
// so I could not have Close[x] in the code.
double def(int x_time)
{
    double sum1=0,sum2=0,k=0,r=0;
    for(int j=calculate; j>x_time; j--)
    {
        k=MathAbs(j-x_time)*0.8325546/width;
        r=MathExp(-k*k);
        if(j<0)
            sum1+=def(j+1)*r;
        else
            sum1+=Close[j]*r;
        sum2+=r;
    }
    return(sum1/sum2);
}